// Written by TeTeT
// based on arma 2 code from Eggbeast and dayz code from Rocket

uns_melee_fnc_throwKnife = {
	params ["_thrower", "_tgt", "_type"];

	_thrower removeMagazine _type;
	_tgt addMagazine _type;

	// Anim seems to do not much
	// _thrower switchMove "AmelPercMstpSnonWnonDnon_zasah6hlava";
	_tgt setDamage 1;
	_thrower say "throw";

	_tgt removeAction (_tgt getVariable ["uns_meleeThrow", -1]);
	_tgt;
};


uns_melee_fnc_stabKnife = {
	params ["_stabber", "_tgt"];

	// Anim seems to do not much
	// _stabber switchMove "AmovPercMrunSrasWrflDf_AmovPercMevaSrasWrflDb";
	_tgt setDamage 1;
	_stabber say "stab";

	_tgt removeAction (_tgt getVariable ["uns_meleeStab", -1]);
	_tgt;
};

uns_melee_fnc_stabBayonet = {
	params ["_stabber", "_tgt"];

	// Anim seems to do not much
	// _stabber switchMove "AmovPercMrunSrasWrflDf_AmovPercMevaSrasWrflDb";
	_tgt setDamage 1;
	_stabber say "stab";

	_tgt removeAction (_tgt getVariable ["uns_meleeStabBayonet", -1]);
	_tgt;
};

[player] spawn {
	params [["_unit", ObjNull]];

	if (isNull _unit) exitWith {};
	if (!local _unit) exitWith {};

	// maybe there's a better way to get these items from config dynamically?
	private _bayonetClasses = ["uns_b_m40_camo", "uns_b_m70_camo", "Uns_acc_bayo_base", "b_smle_1937",
								"uns_b_spike17", "uns_b_sks", "uns_b_6H3", "uns_b_spike", "uns_b_mas49",
								"uns_b_m1", "uns_b_m4", "uns_b_m6", "uns_b_m7", "uns_b_type30", "uns_b_m1917"];

	// evil while loop to see if we're in melee range
	while {alive _unit} do {
		private _tgt = cursorTarget;

		private _magazines = magazines _unit;
		if (_tgt isKindOf "Man") then {
			// Knife support
			if (_tgt distance _unit < 10) then {
				if ("uns_knife" in _magazines or "uns_kabar" in _magazines) then {
					if (_tgt getVariable ["uns_meleeThrow", -1] == -1) then {
						private _type = "uns_knife";
						if ("uns_kabar" in _magazines) then {
							_type = "uns_kabar";
						};
						private _ida = _tgt addAction [
							"Throw knife",
							{[_this select 1, _this select 0, _this select 3] spawn uns_melee_fnc_throwKnife;},
							_type,
							5,
							false,
							true,
							"",
							"_target distance _this < 10 and alive _target"
						];
						// purposely not sending this over the net, so multiple players can target one
						_tgt setVariable ["uns_meleeThrow", _ida];
					};
				};
			};
			if (_tgt distance _unit < 2) then {
				if ("uns_knife" in _magazines or "uns_kabar" in _magazines) then {
					if (_tgt getVariable ["uns_meleeStabBayonet", -1] == -1) then {
						private _ida = _tgt addAction [
							"Stab knife",
							{[_this select 1, _this select 0] spawn uns_melee_fnc_stabKnife;},
							nil,
							5,
							false,
							true,
							"",
							"_target distance _this < 2 and alive _target"
						];
						// purposely not sending this over the net, so multiple players can target one
						_tgt setVariable ["uns_meleeStabBayonet", _ida];
					};
				};
			};
			// Bayonet support
			{
				if (_x in _bayonetClasses) then {
					if (_tgt getVariable ["uns_bayonetStab", -1] == -1) then {
						private _ida = _tgt addAction [
							"Stab bayonet",
							{[_this select 1, _this select 0] spawn uns_melee_fnc_stabBayonet;},
							nil,
							5,
							false,
							true,
							"",
							"_target distance _this < 2 and alive _target"
						];
						// purposely not sending this over the net, so multiple players can target one
						_tgt setVariable ["uns_bayonetStab", _ida];
					};
				};
			} forEach primaryWeaponItems _unit;
		};
		// delay to save some CPU cycles
		sleep 1;
	};

	_unit;
};